;; mydvorak
(require 'quail)
(quail-define-package
;;  "mydvorak" "English" "DV@" t
 "mydvorak" "Japanese" "DV@" t
 "English (ASCII) input method simulating Dvorak keyboard"
 nil t t t t nil nil nil nil nil t)

;; 1!  2@  3#  4$  5%  6&  7`  8(  9)  0~  -=  ^~  \|
;;  '"  ,<  .>  pP  yY  fF  gG  cC  rR  lL  /?  [{
;;   aA  oO  eE  uU  iI  dD  hH  tT  nN  sS  -*  ]}
;;    ;:  qQ  jJ  kK  xX  bB  mM  wW  vV  zZ  \_

(quail-define-rules
 ("1" ?1)
 ("2" ?2)
 ("3" ?3)
 ("4" ?4)
 ("5" ?5)
 ("6" ?6)
 ("7" ?7)
 ("8" ?8)
 ("9" ?9)
 ("0" ?0)
 ("-" ?=)
 ("^" ?^)
 ("\\" ?\\)
 ("!" ?!)
 ("\"" ?@)
 ("#" ?#)
 ("$" ?$)
 ("%" ?%)
 ("&" ?&)
 ("'" ?`)
 ("(" ?\()
 (")" ?\))
 ("=" ?+)
 ("~" ?~)
 ("|" ?|)

 ("q" ?')
 ("w" ?,)
 ("e" ?.)
 ("r" ?p)
 ("t" ?y)
 ("y" ?f)
 ("u" ?g)
 ("i" ?c)
 ("o" ?r)
 ("p" ?l)
 ("@" ?/)
 ("[" ?\[)
 ("Q" ?\")
 ("W" ?<)
 ("E" ?>)
 ("R" ?P)
 ("T" ?Y)
 ("Y" ?F)
 ("U" ?G)
 ("I" ?C)
 ("O" ?R)
 ("P" ?L)
 ("`" ??)
 ("{" ?{)

 ("a" ?a)
 ("s" ?o)
 ("d" ?e)
 ("f" ?u)
 ("g" ?i)
 ("h" ?d)
 ("j" ?h)
 ("k" ?t)
 ("l" ?n)
 (";" ?s)
 (":" ?-)
 ("]" ?\])
 ("A" ?A)
 ("S" ?O)
 ("D" ?E)
 ("F" ?U)
 ("G" ?I)
 ("H" ?D)
 ("J" ?H)
 ("K" ?T)
 ("L" ?N)
 ("+" ?S)
 ("*" ?*)
 ("}" ?})

 ("z" ?\;)
 ("x" ?q)
 ("c" ?j)
 ("v" ?k)
 ("b" ?x)
 ("n" ?b)
 ("m" ?m)
 ("," ?w)
 ("." ?v)
 ("/" ?z)
 ("Z" ?:)
 ("X" ?Q)
 ("C" ?J)
 ("V" ?K)
 ("B" ?X)
 ("N" ?B)
 ("M" ?M)
 ("<" ?W)
 (">" ?V)
 ("?" ?Z)
 ("_" ?_)
 )

(defun my-dvorak-on ()
  "Make original Dvorak on."
  (interactive)
  (set-input-method "mydvorak")
  (setq current-input-method-title " Dvorak ")
  )

(defun my-japanese-input-on ()
  "Make japanese-anthy-uim on."
  (interactive)
  (set-input-method "japanese-anthy-uim")
  )

(defun my-toggle-input-method ()
  "Toggle inpute method."
  (interactive)
  (cond 
   ((string-equal current-input-method "japanese-anthy-uim")
    (my-dvorak-on))
   ((or (string-equal current-input-method "mydvorak")
	(null current-input-method))
    (my-japanese-input-on)))
  )
